<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Form</title>
</head>
<body>
    <h1>Form</h1>
    <form onsubmit="onFormSubmit(this); return false;">
        <input placeholder="name" name="name" value="Daniel">
        <input placeholder="surname" name="surname" value="Zotti">
        <input placeholder="nickname" name="nickname" value="Ciccio">
        <select name="gender">
            <option value="female">Female</option>
            <option value="male" selected="selected">Male</option>
        </select>
        <input placeholder="age" type="number" name="age" value="32">
        <textarea placeholder="note" name="note">Questo è un test.
Ora vado
a capo!
        </textarea> 
        <button>Submit</button>
    </form>
    <script>
        function onFormSubmit(form){

            try {
                // trovo tutti i figli di form che sono dei campi (field)
                // NB: querySelectorAll restituisce una lista di nodi che non è esattamente un array!
                let fieldList = form.querySelectorAll('input,select,textarea');

                /* costruisco un oggetto dallla lista dei campi che ha:
                    CHIAVI: i valori degli attributi "name" dei campi
                    VALORI: i valori degli attributi "value"
                */
                let object = createObjectFromFieldList(fieldList);
                console.log("campi del form (come object)",object);

                // Invio i dati ad un server con metodo POST
                const promise1 = fetch('https://httpbin.org/post', {
                    method: 'POST',
                    headers: {
                        'Accept': 'application/json',
                        'Content-Type': 'application/json'
                    },
                    body: JSON.stringify(object)
                })
                
                promise1.then(function(res){
                    console.log(res.json())
                    // return res.json();
                }).catch(function(err){
                    console.log(err);
                })

                // Attendo la risposta e la stampo in console
                // console.log("Risposta del server", response);

                return false;
            }
            catch(e) {
                console.log(e)
                return false;
            }
        }

        function createObjectFromFieldList(list){
            // trasformo la lista dei campi del form in un array
            let array = Array.from(list);

            // utilizzo la funzione reduce degli array per creare l'oggetto ciclando sugli elementi
            return array.reduce(function(obj,el){
                    obj[el.name] = el.value;
                    console.log(obj);
                    return obj;
                },{});
        }

        // let numbers = [1,2,3,4];
        // console.log(numbers);
        // numbers.reduce(function(prev,current){
        //     console.log('prev',prev,'current',current);
        //     return prev + current;
        // },0);
    </script>
</body>
</html>